<link rel="import" href="../../../polymer/polymer-element.html" />

<dom-module id="app-datos-personales">
    <template>
        <link rel="stylesheet" href="css/bulma.min.css" />
        <div class="card">
            <header class="card-header" on-click="ocultarSeccion">
                <p class="card-header-title has-text-primary is-uppercase">Datos personales</p>
                <a class="card-header-icon">
                    <span class="icon">🔽</span>
                </a>
            </header>
            <div class="card-content">
                <div class="content">
                    <div class="columns">
                        <div class="column">
                            <div class="field">
                                <label class="label" for="nombre">Nombre(s):</label>
                                <input
                                    class="input is-rounded"
                                    type="text"
                                    id="nombre"
                                    value="{{nombre::input}}"
                                    placeholder="Juan"
                                />
                            </div>
                        </div>
                        <div class="column">
                            <div class="field">
                                <label class="label" for="apellidos">Apellidos:</label>
                                <input
                                    class="input is-rounded"
                                    type="text"
                                    id="apellidos"
                                    value="{{apellidos::input}}"
                                    placeholder="Perez"
                                />
                            </div>
                        </div>
                    </div>

                    <div class="columns">
                        <div class="column">
                            <label class="label" for="curp">CURP</label>
                            <input
                                class="input is-rounded"
                                type="text"
                                id="curp"
                                value="{{curp::input}}"
                                placeholder="XXXX000000XXXXXX00"
                            />
                        </div>
                        <div class="column">
                            <label class="label" for="celular">Teléfono móvil:</label>
                            <div class="field has-addons">
                                <p class="control">
                                    <span class="select">
                                        <select id="codigo">
                                            <option value="MX">México (+52)</option>
                                        </select>
                                    </span>
                                </p>
                                <p class="control">
                                    <input
                                        type="tel"
                                        class="input"
                                        placeholder="5512345678"
                                        value="{{celular::input}}"
                                        id="celular"
                                    />
                                </p>
                            </div>
                        </div>
                        <div class="column">
                            <label class="label">Fecha de nacimiento:</label>
                            <div class="field">
                                <div class="select is-rounded">
                                    <select id="dia">
                                        <template is="dom-repeat" items="{{days}}">
                                            <option value="d{{item}}">{{item}}</option>
                                        </template>
                                    </select>
                                </div>
                                <div class="select is-rounded">
                                    <select id="mes" on-change="actualizarDias">
                                        <template is="dom-repeat" items="{{months}}">
                                            <option value="m[[index]]">[[item]]</option>
                                        </template>
                                    </select>
                                </div>
                                <div class="select is-rounded">
                                    <select id="año" on-change="actualizarDias">
                                        <template is="dom-repeat" items="{{years}}">
                                            <option value="a[[item]]">[[item]]</option>
                                        </template>
                                    </select>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="field has-text-centered">
                        <button type="button" class="button is-primary" on-click="guardarCambios">
                            Guardar cambios
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </template>

    <script>
        class AppDatosPersonales extends Polymer.Element {
            static get is() {
                return "app-datos-personales";
            }
            static get properties() {
                return {
                    days: {
                        type: Array,
                        notify: true,
                        value() {
                            return Array.from({ length: 31 }, (e, i) => i + 1);
                        },
                    },
                    months: {
                        type: Array,
                        value: Array.from({ length: 12 }, (e, i) => {
                            return new Date(null, i + 1, null).toLocaleDateString("es", {
                                month: "long",
                            });
                        }),
                    },
                    years: {
                        type: Array,
                        value() {
                            return Array.from({ length: 100 }, (e, i) => i + 1950);
                        },
                    },
                    nombre: {
                        type: String,
                        notify: true,
                    },
                    apellidos: {
                        type: String,
                        notify: true,
                    },
                    curp: {
                        type: String,
                        notify: true,
                    },
                    celular: {
                        type: String,
                        notify: true,
                    },
                };
            }
            _esBisiesto(año) {
                return (año % 4 == 0 && año % 100 != 0) || año % 400 == 0;
            }
            ocultarSeccion() {
                this.shadowRoot.querySelector(".card-content").classList.toggle("is-hidden");
            }
            actualizarDias(e) {
                const dias = new Set(this.days);
                const mes = parseInt(this.$.mes.value.slice(1));
                const bisiesto = this._esBisiesto(this.$.año.value.slice(1));

                const d30 = [3, 5, 7, 8, 10];
                if (mes === 1) {
                    dias.delete(31);
                    dias.delete(30);
                    if (!bisiesto) {
                        dias.delete(29);
                    } else {
                        dias.add(29);
                    }

                    return (this.days = Array.from(dias));
                }

                if (d30.includes(mes)) {
                    dias.add(29);
                    dias.add(30);
                    dias.delete(31);
                } else {
                    dias.add(29);
                    dias.add(30);
                    dias.add(31);
                }
                this.days = Array.from(dias);
            }
            guardarCambios() {
                console.log(this.nombre);
                console.log(this.apellidos);
                console.log(this.curp);
                console.log(this.$.codigo.value);
                console.log(this.celular);
                console.log(this.$.dia.value);
                console.log(this.$.mes.value);
                console.log(this.$.año.value);
                alert("Conexión al servidor pendiente, los datos están en la consola");
            }
        }

        window.customElements.define(AppDatosPersonales.is, AppDatosPersonales);
    </script>
</dom-module>
